--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...


local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		HealthWrapper:SetSize(131,36)
		HealthWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		HealthWrapper:SetBackdropColor(0,0,0,0)
		HealthWrapper:SetBackdropBorderColor(1,1,1,1)
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		PowerWrapper:SetSize(131,29)
		PowerWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(1,1,1,1)
end
local function CastBarWrap(frame)
	local CastBarWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		CastBarWrapper:SetPoint("LEFT",frame,"LEFT",-2,0)
		CastBarWrapper:SetSize(185,23)
		CastBarWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 10,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		CastBarWrapper:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		CastBarWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function AltPowerWrap(frame)
	local AltPowerWrap = CreateFrame("Frame","AltPowerWrap",frame, BackdropTemplateMixin and "BackdropTemplate")
		AltPowerWrap:SetPoint("LEFT",frame,"LEFT",-2,0)
		AltPowerWrap:SetSize(128,23)
		--AltPowerWrap:SetAllPoints(frame)
		AltPowerWrap:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 10,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		AltPowerWrap:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		AltPowerWrap:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function CastBarBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,1)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function HealthBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0.3,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function PowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function RuneBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 8,
		insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(1,1,1,0)
end
local function PortraitWrap(frame)
	local PortraitWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PortraitWrapper:SetFrameLevel(1)
		PortraitWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PortraitWrapper:SetSize(68,64)
		PortraitWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PortraitWrapper:SetBackdropColor(0,0,0,1)
		PortraitWrapper:SetBackdropBorderColor(1,1,1,1)
end
local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end

local FocusMover = CreateFrame("Frame","FocusDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	FocusMover:SetSize(132,55)
	FocusMover:SetPoint("CENTER",UIParent,"CENTER",-535,75)
	
	FocusMover:SetClampedToScreen(true)
	FocusMover:SetClampRectInsets(0, 0, 0,0)
	
local FocusMoverText  = FocusMover:CreateFontString(nil, "OVERLAY")
	FocusMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	FocusMoverText:SetPoint("CENTER",FocusMover,"CENTER", 0,0); 
	FocusMoverText:SetText("")
	
local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.FocusFrameEnable == true then 
				Inked.db.profile.FocusX = 0
				Inked.db.profile.FocusY = 0
				local point, relativeTo, relativePoint, xOfs, yOfs = FocusMover:GetPoint(n)
				Inked.db.profile.FocusX = xOfs
				Inked.db.profile.FocusY = yOfs
				Inked.db.profile.FocusPoint = point
				FocusMover:SetMovable(true)
				FocusMover:EnableMouse(true)
				FocusMover:RegisterForDrag("LeftButton")
				FocusMover:SetScript("OnDragStart", FocusMover.StartMoving)
				FocusMover:SetScript("OnDragStop", FocusMover.StopMovingOrSizing)
				FocusMover:SetUserPlaced(true)
				FocusMoverText:SetText("Focus Frame")
				CreateMoverBackdrop(FocusMover)
			end
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

local UnitSpecific = {
	
	focus = function(self)
	if Inked.db.profile.FocusFrameEnable == false then return end

		--------------------
		--  Focus Set Up --
		--------------------
		local FocusWidth = 123;
		local FocusHeight = 55;
		local PortraitWidth = 55;
		local PortraitHeight = 52;
		self:SetSize(FocusWidth,FocusHeight)

		-------------------------------------
		--  Adjust Focus Health and Power --
		-------------------------------------

		self.Health:SetHeight(31)
		self.Power:SetHeight(22)

		-------------------------
		--  Focus Level Value --
		-------------------------
		if Inked.db.profile.FocusShowLevel == true then
			
			local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
			if Inked.db.profile.FocusPortrait == true then
				LevelText:SetPoint("RIGHT", self, 124,20)
			elseif Inked.db.profile.FocusPortrait == false then
				LevelText:SetPoint("RIGHT", self, 55,20)
			end
			LevelText:SetFont(LSM:Fetch("font", Inked.db.profile.FocusLevelfont), Inked.db.profile.FocusLevelFontSize, Inked.db.profile.FocusLevelOutline)
			LevelText:SetWidth(50)
			LevelText:SetJustifyH("LEFT")
			self:Tag(LevelText, "[level]") 
		end
		-------------------------
		--  Focus Name Value --
		-------------------------
		if Inked.db.profile.FocusShowName == true then
			local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
			NameText:SetPoint("TOPLEFT", self, 0,20) 
			NameText:SetJustifyH("LEFT")
			NameText:SetFont(LSM:Fetch("font", Inked.db.profile.FocusNamefont), Inked.db.profile.FocusNameFontSize, Inked.db.profile.FocusNameOutline)
			NameText:SetWidth(400)
			self:Tag(NameText, "[name]")
		end
		-------------------------
		--  Focus Power Value --
		-------------------------
		
		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.FocusShowPowerPercent == true then
			PowerText:SetPoint("CENTER", self, 0,-20)
		elseif Inked.db.profile.FocusShowBothPowerNumberandPercent == true then
			PowerText:SetPoint("LEFT", self, 5,-20)
		end		
		PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.FocusPowerfont), Inked.db.profile.FocusPowerFontSize, Inked.db.profile.FocusPowerOutline)
		self:Tag(PowerText, "[perpp]".." %") 


		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.FocusShowPowerNumbers == true then
			PowerText2:SetPoint("CENTER", self, 0,-20)
		elseif Inked.db.profile.FocusShowBothPowerNumberandPercent == true then
			PowerText2:SetPoint("RIGHT", self, -5,-20)
		end		
		PowerText2:SetFont(LSM:Fetch("font", Inked.db.profile.FocusPowerfont), Inked.db.profile.FocusPowerFontSize, Inked.db.profile.FocusPowerOutline)
		self:Tag(PowerText2, "[Inked:MyPower]") 

		--------------------------
		--  Focus Health Value --
		--------------------------
		
		

		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.FocusShowHealthPercent == true then
			HealthText:SetPoint("CENTER", self, 0,12)
		elseif Inked.db.profile.FocusShowBothNumberandPercent == true then
			HealthText:SetPoint("LEFT", self, 5,12)
		end	
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.FocusHealthfont), Inked.db.profile.FocusHealthFontSize, Inked.db.profile.FocusHealthOutline)
		self:Tag(HealthText, "[perhp]".." %") 

		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.FocusShowHealthNumbers == true then
			HealthText2:SetPoint("CENTER", self, 0,12)
		elseif Inked.db.profile.FocusShowBothNumberandPercent == true then
			HealthText2:SetPoint("RIGHT", self, -5,12)
		end	
		HealthText2:SetFont(LSM:Fetch("font", Inked.db.profile.FocusHealthfont), Inked.db.profile.FocusHealthFontSize, Inked.db.profile.FocusHealthOutline)
		self:Tag(HealthText2, "[Inked:MyHealth]") 


		----------------------
		--  Focus Portrait --
		----------------------
		if Inked.db.profile.FocusPortrait == true then
			self.Portrait:SetPoint('LEFT', self, 'RIGHT',9,-2)
			self.Portrait:SetSize(PortraitWidth, PortraitHeight)
		end
 
		-----------------------
		--  Focus Cast bar --
		-----------------------
		if Inked.db.profile.FocusCastBar == true then
		self.Castbar:SetSize(180, 20)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Health, 2, -65)
		end

		-----------------------------
		-- Focus Auras
		-----------------------------
		if Inked.db.profile.FocusAuras == true then
		local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,40)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 60, 40)
		Auras:SetHeight(25)
		Auras:SetHeight(25 + 4)

		Auras.size = 25
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end

		
	--------------
	-- Rez Icon --
	--------------

	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('LEFT', self,-28,-24)

	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	--------------------------
	-- Group Role Indicator --
	--------------------------
	
	  -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('LEFT', self,-28,24)

    -- Register it with oUF
    self.GroupRoleIndicator = GroupRoleIndicator

	----------------
	-- Raid icons --
	----------------

	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('LEFT', self,-28,0)

	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
	
	local PvPIndicator = self:CreateTexture(nil, 'ARTWORK', nil, 1)
    PvPIndicator:SetSize(30, 30)
    PvPIndicator:SetPoint('LEFT', self, 'RIGHT',0,-5)

    local Badge = self:CreateTexture(nil, 'ARTWORK')
    Badge:SetSize(50, 52)
    Badge:SetPoint('CENTER', PvPIndicator, 'CENTER')

    -- Register it with oUF
    PvPIndicator.Badge = Badge
    self.PvPIndicator = PvPIndicator

	end, -- End focus
	
	
}
	

local Shared = function(self, unit)
if Inked.db.profile.FocusFrameEnable == false then return end
	self:SetScale(Inked.db.profile.FocusScale)
-- Shared layout code.
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.FocusHealthStatusBar))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetReverseFill(true);
	HealthWrap(Health)
	CreateBackdrop(Health)
	

	-- Options
	--Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	--self.Health.bg = Healthbg
	Health:SetFrameLevel(2)

		

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.FocusPowerStatusBar))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-27)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetReverseFill(true);
	Power:SetFrameLevel(1)
	PowerWrap(Power)
	CreateBackdrop(Power)


	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true 
	Power.colorClassNPC = false 
	Power.colorClassPet = false 
	-- Register it with oUF
	self.Power = Power


	------------------
	--   Portrait --
	------------------
	if Inked.db.profile.FocusPortrait == true then
	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")
	PortraitWrap(Portrait)		
	-- Register it with oUF
	self.Portrait = Portrait
	end

	--------------
	-- Cast Bar --
	--------------

	if Inked.db.profile.FocusCastBar == true then
		local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.FocusCastBarStatusBar))
		Castbar:SetReverseFill(true);
		Castbar:SetStatusBarColor(0.85, 0.15, 0.85, 0.85)
		CastBarWrap(Castbar)
		

		-- Add a background
		CreateBackdrop(Castbar)
		-- Add a spark
		local Spark = Castbar:CreateTexture(nil, "OVERLAY")
		Spark:SetSize(40, 12)
		Spark:SetBlendMode("ADD")

		-- Add a timer
		local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Time:SetFont(LSM:Fetch("font", Inked.db.profile.FocusCastBarfont), Inked.db.profile.FocusCastBarFontSize, Inked.db.profile.FocusCastBarOutline)
		Time:SetTextColor(0.99, 0.99, 0.99)
		Time:SetPoint("LEFT", Castbar, 3, 1)

		-- Add spell text
		local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Text:SetFont(LSM:Fetch("font", Inked.db.profile.FocusCastBarfont), Inked.db.profile.FocusCastBarFontSize, Inked.db.profile.FocusCastBarOutline)
		Text:SetTextColor(0.99, 0.99, 0.99)
		Text:SetPoint("RIGHT", Castbar, -3, 1)

		-- Add Shield
		local Shield = Castbar:CreateTexture(nil, "OVERLAY")
		Shield:SetSize(25, 15)
		Shield:SetPoint("CENTER", Castbar)

		local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
		Icon:SetSize(23, 23)
		Icon:SetPoint('LEFT', Castbar, 'RIGHT', 3,0)
		-- Add safezone
		local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

		-- Register it with oUF
		self.Castbar = Castbar
		self.Castbar.bg = Background
		self.Castbar.Spark = Spark
		self.Castbar.Time = Time
		self.Castbar.Text = Text
		self.Castbar.SafeZone = SafeZone
		self.Castbar.Icon = Icon
	end

	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end


	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedFocus", Shared)
oUF:Factory(function(self)
if Inked.db.profile.FocusFrameEnable == false then return end
	-----------------
	-- Unit Set Up --
	-----------------
	self:SetActiveStyle("InkedFocus")
	if Inked.db.profile.FocusPoint == nil then
		 self:Spawn("focus"):SetPoint("Center",UIParent,Inked.db.profile.FocusX,Inked.db.profile.FocusY)
		FocusMover:SetPoint("Center",UIParent,Inked.db.profile.FocusX,Inked.db.profile.FocusY)
	  else
		 self:Spawn("focus"):SetPoint(Inked.db.profile.FocusPoint,UIParent,Inked.db.profile.FocusX,Inked.db.profile.FocusY)
		FocusMover:SetPoint(Inked.db.profile.FocusPoint,UIParent,Inked.db.profile.FocusX,Inked.db.profile.FocusY)
	  end
	--self:Spawn("focus"):SetPoint("CENTER",UIParent,-535,75)
	

end)